/**
 * 又拍云上传
 * @param {Object} file
 * 
 */

function upyunUpload ( file ){
	var conf={
		success: function(txt){},
		error:function(){},
		'type':'img',
		$:mui 
	}
	if(arguments.length>1){
		conf.$.extend(conf, arguments[1]);
	}
	//正式上传
	var doUpyun = function(rep){
		//console.error( JSON.stringify(rep.data ));
		if(rep.error!=0){
			return false ;
		}
		
		var task = plus.uploader.createUpload( rep.data.action, 
			{ method:"POST",blocksize:2048000,priority:100 },
			function ( t, status ) {
				// 上传完成
				if ( status == 200 ) { 	
					console.error( t.responseText );
					
					var obj= JSON.parse( t.responseText );					
					
					if( obj.task_ids!=undefined ){  //当有异步任务时候 需要去检查
						taskCheck( obj );
					}else{
						conf.success( obj ) ;
					}
				} else {
					conf.error(t,status); 
				}
			}
		); 
		task.addFile( file, {key:"file"} );
		task.addData( "policy",  rep.data.policy );
		task.addData( "signature",  rep.data.signature );
		task.start();
	}
	
	//异步检查
	var taskCheck = function( obj  ){
		console.log("taskCheck start "); 
		var task_ids = obj.task_ids;
		var sign= null ;
		var starCheck= function(){
			app.ajax({
				url:'/d3/youyun/task.php' ,
				data:{'task': task_ids.join(',') }, 
				success:initTask
			});
		}
		 
		var initTask= function(rep){ 
			if(rep.error==0 ){
				sign= rep.data;
				doCheck();
			}
		}
		var doCheck= function(){ 
			conf.$.ajax({ 
				url: sign.checkUrl+'?'+sign.data ,
				'dataType':'json',
				headers:{'Authorization':'UPYUN '+sign.operator+':'+sign.sign }	,
				success:function(rep){	
					var yes= true ;
					for( p in rep.tasks ){
						if(rep.tasks[p] != 100 ) yes= false ;
					}
					if( yes )getRz();
					else setTimeout( doCheck,100);
				}
			});
		}
		
		var getRz = function(){//resultUrl
			conf.$.ajax({ 
				url: sign.resultUrl+'?'+sign.data ,
				'dataType':'json',
				headers:{'Authorization':'UPYUN '+sign.operator+':'+sign.sign }	,
				success:function(rep){	
					try{
						var d={};
						for( p in rep.tasks ){
							//if(rep.tasks[p] != 100 ) yes= false ;
							d[p]=str2obj( rep.tasks[p]) ;
						}
						//console.error( JSON.stringify( d )); 
						obj.task_result = d ;
						for(p in  obj.task_result ){
							var to = obj.task_result[p]; break;
						}
						obj.task_path= to['path[0]'];
					} catch(e){
						console.error("UPYun Error: "+ JSON.stringify( rep));
						setTimeout( doCheck  ,500);
					}					
					conf.success( obj  ); 
				}
			});
		}
		var str2obj = function( str ){
			var o = {};
			var arr = str.split("&");
			for(var i=0; i<arr.length; i++){
				var arr2= arr[i].split("=",2);
				o[ arr2[0]]= arr2[1];
			}
			return o;
		}
		starCheck(); 
	}
	
	//上传准备动作 取配置 又拍云的tick信息
	var dostart= function(){
		app.ajax({
			url:'/d3/youyun/?type='+conf.type ,
			success:doUpyun
		});
	}
	
	//图片压缩
	var zipimg= function(){
		var timg = new Image();
		timg.src="file://"+ file ;
		timg.onload= function(){
			var tofile= "_doc/zip_"+file.split('/').pop();					
			console.error("width:"+ timg.width +"\ttofile:"+ tofile  );
			var opt={
				src: "file://"+ file,
				dst:tofile,
				overwrite:true
			}
			if(timg.width>timg.height){
				if( timg.height>500){
					opt.height ='500px';
				}else if(timg.width>1000){
					opt.width="1000px";
				}				
			}else{
				if( timg.width>500){
					opt.width='500px';
				}else if(timg.height>1000){
					opt.height="1000px";
				}
			}
			plus.zip.compressImage( opt
				,function(){
					file= tofile;
					dostart();
				}
				,conf.error );
			
		}
		timg.onerror= function(){
			//console.error("error:\t "+ timg.src  );
			conf.error("zip error");
		}
		return false ;
	}
	
	//开始入口
	var gostart= function(){
		ext= file.split('.').pop();
		console.error("ext:"+ ext ); 
		conf.type= ext; 
		
		if( ext!=undefined && (ext.toLowerCase()=='png'||ext.toLowerCase()=='jpg' ) ){
			zipimg();
		}else{ 
			dostart();
		}
		
	}
	gostart();	
}